package com.bonus.material.ma.mapper;

import java.util.List;

import com.bonus.common.biz.domain.TreeNode;
import com.bonus.material.ma.domain.PartType;
import com.bonus.material.ma.domain.vo.MaTypeVo;
import org.apache.ibatis.annotations.Param;

/**
 * 配件类型管理Mapper接口
 * 
 * @author xsheng
 * @date 2024-09-27
 */
public interface PartTypeMapper 
{
    /**
     * 查询配件类型管理
     * 
     * @param id 配件类型管理主键
     * @return 配件类型管理
     */
    public PartType selectPartTypeByPaId(Long id);

    /**
     * 查询配件类型管理列表
     * 
     * @param partType 配件类型管理
     * @return 配件类型管理集合
     */
    public List<TreeNode> selectPartTypeList(PartType partType);

    /**
     * 新增配件类型管理
     * 
     * @param partType 配件类型管理
     * @return 结果
     */
    public int insertPartType(PartType partType);

    /**
     * 修改配件类型管理
     * 
     * @param partType 配件类型管理
     * @return 结果
     */
    public int updatePartType(PartType partType);

    /**
     * 删除配件类型管理
     * 
     * @param id 配件类型管理主键
     * @return 结果
     */
    public int deletePartTypeByPaId(Long id);

    /**
     * 获取配件类型树
     * @param dto
     * @return
     */
    List<TreeNode> getPartTree(PartType dto);

    /**
     * 获取配件类型列表
     * @param partType
     * @return
     */
    List<PartType> getTypeList(PartType partType);

    /**
     * 根据名称查询
     * @param partType
     * @return
     */
    PartType selectByName(PartType partType);

    /**
     * 根据id查询
     * @param id
     * @return
     */
    int selectById(Long id);

    /**
     * 查询配件是否在用
     * @param id
     * @return
     */
    int selectPart(Long id);

    /**
     * 根据level层级和typeID 查询父级ID
     * @param partType
     */
    List<Integer> selectParentId(PartType partType);

    List<PartType> getListByTypeName(@Param("paId") Long id, @Param("type") PartType partType);
}
